<?xml version="1.0"?>
<launch>

  <!-- Set to true if communicating through the VIB .. set the default port-->
  <arg name="vib" default="true"/>
  <arg name="joint_states_topic" default="/joint_states"/>

  <node name="tilt_nodder" pkg="md_actuator_driver" type="nodder" output="screen" ns="tilt">

  </node>

  <node name="md_actuator" pkg="md_actuator_driver" type="md_actuator_driver" output="screen" ns="tilt">
    <!-- joint_states topic needs to match whatever joint_state_publisher is expecting,
         rather than being namespaced with the rest of the tilt topics. -->
    <remap from="joint_states" to="$(arg joint_states_topic)"/>

    <param name="port" value="socket://vib.raven.apl.uw.edu:1003/" if="$(arg vib)"/>
    <param name="port" value="/dev/ttyUSB1" unless="$(arg vib)" />

    <!-- This defines the "frame_id" use for the joint.-->
    <param name="axis" value="tilt_joint"/>

    <!-- In air and unloaded, 0.2 was ~3RPM or ~18 deg/sec. -->
    <!-- Looking at the data live, 0.2 was pretty fast, and 0.1 excruciatingly slow.-->
    <param name="duty_cycle" value="0.15"/>

    <!-- MD Actuator's encoder reading converted to degrees when sensors are pointing straight ahead. -->
    <param name="zero_offset" value="255.5"/>
    <!-- min/max range of motion, relative to the zero offset. -->
    <param name="min_degrees" value="-70"/>
    <param name="max_degrees" value="70"/>
    <param name="move_threshold" value="0.25"/>

    <rosparam>
      <!-- Period (in units of 10ms) of status messages. 0-127. If <10, will only publish status after a command. -->
      talk_back_interval: 10
      <!-- Dead band on duty cycle. If controller would output lower command than this, actuator will stop.
           Defaults to 10; documentation says to increase it if the actuator starts stalling out at low speeds/higher loads. -->
      dead_band: 7
      <!-- Duty (speed) value for final approach to goal position. Must be higher than dead_band. -->
      decel_min: 10
      <!-- Distance from target (in counts) at which control slows down to decel_min.
          This is in counts, and default is ~13 degrees at the shaft. Our gear ratio is 1:1 -->
      decel_space: 151
      <!-- Soft limit at which acuator will stop, in counts.
          If commanded to go below this, will report "Over Limit" error.
          Value chosen with Jess closely watching cables for any tension, and checking that
          full min->max moves were OK. -->
      virtual_min: 8192
      <!-- Soft limit at which acuator will stop, in counts.
           If commanded to go above this, will report "Over Limit" error.
           Absolute max will be 2**40; there are 2**14=16384 counts/turn. -->
      virtual_max: 15018
    </rosparam>
  </node>
</launch>
